## visad
Class RemoteFunctionImpl

    java.lang.Object
      java.rmi.server.RemoteObject
          java.rmi.server.RemoteServer
              java.rmi.server.UnicastRemoteObject
                  visad.RemoteThingImpl
                      visad.RemoteDataImpl
                          visad.RemoteFunctionImpl

All Implemented Interfaces:
  Data, Function, Remote, RemoteData, RemoteFunction, RemoteThing, Serializable, Thing

Direct Known Subclasses:
  RemoteFieldImpl

public abstract class RemoteFunctionImpl
extends RemoteDataImpl
implements RemoteFunction

RemoteFunctionImpl is the VisAD remote adapter for FieldImpl.

See Also:
  Serialized Form

Field Summary

Fields inherited from class visad.RemoteDataImpl
`AdaptedData`

Fields inherited from class visad.RemoteThingImpl
`AdaptedThing`

Fields inherited from class java.rmi.server.RemoteObject
`ref`

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Constructor Summary
`RemoteFunctionImpl(FunctionImpl function)`

Method Summary
`Data` `derivative(int error_mode)` return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; propogate errors according to error_mode
`Data` `derivative(MathType[] derivType_s, int error_mode)` return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

`Data`

`derivative(RealTuple location, RealType[] d_partial_s, MathType[] derivType_s, int error_mode)`
return the tuple of derivatives of this Function with respect to the RealTypes in d_partial_s; the RealTypes in d_partial_s may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

`Function` `derivative(RealType d_partial, int error_mode)` return the derivative of this Function with respect to d_partial; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode
`Function` `derivative(RealType d_partial, MathType derivType, int error_mode)` return the derivative of this Function with respect to d_partial; set result MathType to derivType; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode
`Data` `evaluate(Real domain)` Evaluate this Function at domain; for 1-D domains use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)
`Data` `evaluate(Real domain, int sampling_mode, int error_mode)` Evaluate this Function, for 1-D domains, with non-default modes for resampling and errors
`Data` `evaluate(RealTuple domain)` Evaluate this Function at domain; use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)
`Data` `evaluate(RealTuple domain, int sampling_mode, int error_mode)` Evaluate this Function with non-default modes for resampling and errors
`CoordinateSystem` `getDomainCoordinateSystem()` Get the CoordinateSystem associated with the domain RealTuple
`int` `getDomainDimension()` methods adapted from Function
`Unit[]` `getDomainUnits()` Get the default Units of the Real components of the domain.
`Field` `resample(Set set)` Return a Field of Function values at the samples in set using default sampling_mode (WEIGHTED_AVERAGE) and error_mode (NO_ERRORS); This combines unit conversions, coordinate transforms, resampling and interpolation
`Field` `resample(Set set, int sampling_mode, int error_mode)` can decide whether to return the local FieldImpl returned by ((FunctionImpl) AdaptedData).resample, or whether to return a RemoteFunctionImpl adapted for that FieldImpl; the same is true for the methods: extract, binary, unary, evaluate and getSample (as long as their return value is an instanceof Field)

Methods inherited from class visad.RemoteDataImpl

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, computeRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, isMissing, local, log, log, longString, longString, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from class visad.RemoteThingImpl
`addReference, getTick, incTick, removeReference`

Methods inherited from class java.rmi.server.UnicastRemoteObject
`clone, exportObject, exportObject, exportObject, unexportObject`

Methods inherited from class java.rmi.server.RemoteServer
`getClientHost, getLog, setLog`

Methods inherited from class java.rmi.server.RemoteObject
`equals, getRef, hashCode, toString, toStub`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface visad.Data

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, computeRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, isMissing, local, log, log, longString, longString, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Methods inherited from interface visad.RemoteThing
`getTick, incTick`

Constructor Detail

### RemoteFunctionImpl

    public RemoteFunctionImpl(FunctionImpl function)
                       throws RemoteException

Method Detail

### getDomainDimension

    public int getDomainDimension()
                           throws VisADException,
                                  RemoteException

  methods adapted from Function

  Specified by:
    `getDomainDimension` in interface `Function`
  Returns:
    number of RealType components (n in R^n space)
  Throws:
    `VisADException`
    `RemoteException`

### getDomainUnits

    public Unit[] getDomainUnits()
                          throws VisADException,
                                 RemoteException

  Description copied from interface: `Function`
  Get the default Units of the Real components of the domain.

  Specified by:
    `getDomainUnits` in interface `Function`
  Returns:
    array of Unit-s in the same order as the RealTypes in the domain.
  Throws:
    `VisADException`
    `RemoteException`

### getDomainCoordinateSystem

    public CoordinateSystem getDomainCoordinateSystem()
                                               throws VisADException,
                                                      RemoteException

  Description copied from interface: `Function`
  Get the CoordinateSystem associated with the domain RealTuple

  Specified by:
    `getDomainCoordinateSystem` in interface `Function`
  Returns:
    CoordinateSystem of the domain
  Throws:
    `VisADException`
    `RemoteException`

### evaluate

    public Data evaluate(Real domain)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function at domain; for 1-D domains use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(Real domain,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function, for 1-D domains, with non-default modes for resampling and errors

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(RealTuple domain)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function at domain; use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(RealTuple domain,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function with non-default modes for resampling and errors

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### resample

    public Field resample(Set set)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Function`
  Return a Field of Function values at the samples in set using default sampling_mode (WEIGHTED_AVERAGE) and error_mode (NO_ERRORS); This combines unit conversions, coordinate transforms, resampling and interpolation

  Specified by:
    `resample` in interface `Function`
  Parameters:
    `set` - finite sampling values for the function.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `RemoteException` - Java RMI exception
    `VisADException` - unable to resample function

### resample

    public Field resample(Set set,
                          int sampling_mode,
                          int error_mode)
                   throws VisADException,
                          RemoteException

  can decide whether to return the local FieldImpl returned by ((FunctionImpl) AdaptedData).resample, or whether to return a RemoteFunctionImpl adapted for that FieldImpl; the same is true for the methods: extract, binary, unary, evaluate and getSample (as long as their return value is an instanceof Field)

  Specified by:
    `resample` in interface `Function`
  Parameters:
    `set` - finite sampling values for the function.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to resample function
    `RemoteException` - Java RMI exception

### derivative

    public Data derivative(RealTuple location,
                           RealType[] d_partial_s,
                           MathType[] derivType_s,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Function`
  return the tuple of derivatives of this Function with respect to the RealTypes in d_partial_s; the RealTypes in d_partial_s may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Data derivative(int error_mode)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Function`
  return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Data derivative(MathType[] derivType_s,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Function`
  return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Function derivative(RealType d_partial,
                               int error_mode)
                        throws VisADException,
                               RemoteException

  Description copied from interface: `Function`
  return the derivative of this Function with respect to d_partial; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Function derivative(RealType d_partial,
                               MathType derivType,
                               int error_mode)
                        throws VisADException,
                               RemoteException

  Description copied from interface: `Function`
  return the derivative of this Function with respect to d_partial; set result MathType to derivType; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`